{{{

*****************************************
*      FIR Filter Propeller Object      *
*  generated by www.phipi.com/fir2pasm  *
*  from the parameters given in the DAT *
*          section of this file.        *
*****************************************

Created: Sun Jul 24 17:36:16 2011 UTC

}}

CON

  SIZE          = 46
  BITS          = 12

VAR

  long  busy, value[2]

PUB start

  '' Start the FIR filter cog.

  cognew(@fir_filter, @busy)
  
PUB filterab(yy)

  '' Perform both filtera and filterb on yy. Return the address of the results.

  value := yy
  busy := 3
  repeat while busy
  return @value
  
PUB filtera(yy)

  '' Return the current FIR-filtered value of sample yy in data stream,
  '' using filtera.

  value := yy
  busy := 1
  repeat while busy
  return value

PUB filterb(yy)

  '' Return the current FIR-filtered value of sample yy in data stream,
  '' using filterb.

  value := yy
  busy := 2
  repeat while busy
  return value

DAT

'==========================================================================
'Parameters Given
'
'  46 coefficients:
'
'    -1.72786881e-02
'    +3.10354904e-17
'    -1.76846441e-02
'    +3.31432223e-17
'    -1.73439905e-02
'    +3.02565394e-17
'    -1.60229387e-02
'    +2.27231548e-17
'    -1.34114127e-02
'    +9.39854771e-18
'    -9.05858098e-03
'    -1.35002931e-17
'    -2.23058069e-03
'    +6.32752957e-17
'    +8.43722283e-03
'    +1.86916059e-16
'    +2.59349330e-02
'    +1.92532318e-16
'    +5.85305268e-02
'    -7.51869211e-17
'    +1.40958882e-01
'    -4.70574169e-17
'    +8.64149720e-01
'    +1.41337340e-16
'    -3.32860925e-01
'    +2.81684992e-17
'    -1.57566632e-01
'    +4.65642616e-17
'    -1.06687855e-01
'    -1.59115340e-17
'    -8.05483160e-02
'    -3.98477389e-18
'    -6.34975663e-02
'    -3.15391450e-18
'    -5.08450339e-02
'    -2.57753564e-17
'    -4.07381277e-02
'    +4.30191430e-18
'    -3.23254720e-02
'    -1.82032973e-18
'    -2.51775169e-02
'    -1.24412119e-17
'    -1.90622210e-02
'    -8.55597863e-17
'    -1.38450627e-02
'    -2.88392941e-17
'
'  Stated gain:  1.0000000
'  Desired gain: 1.0000000
'  Precision:    12 bits
'  Channels:     Dual Reversed
'
'Resulting PASM instructions (not including overhead):
'
'  h*x computation:    85
'  Each y computation: 68
'
'==========================================================================

              org      0
fir_filter    mov      xy_addr,par              'Initialize the hub address for the data exchange.
              add      xy_addr,#4
              mov      yb_addr,par
              add      yb_addr,#8

'Further user initialization code can be added here.

main_lp       wrlong   zero,par                 'DO NOT MODIFY.

'The next line can be altered to acquire the next input sample in another way.
'On return, sel indicates which channel(s) to process: bit 0 for a; bit 1 for b.

              call      #get_x                  'Read the next input.

'Computes the h * x values for the current x.

              mov       h+11,x                  'DO NOT MODIFY.
              sar       x,#2                    'DO NOT MODIFY.
              mov       h+10,x                  'DO NOT MODIFY.
              sar       x,#1                    'DO NOT MODIFY.
              mov       h+9,x                   'DO NOT MODIFY.
              mov       h+8,x                   'DO NOT MODIFY.
              mov       h+12,x                  'DO NOT MODIFY.
              sub       h+11,x                  'DO NOT MODIFY.
              sar       x,#1                    'DO NOT MODIFY.
              mov       h+6,x                   'DO NOT MODIFY.
              mov       h+5,x                   'DO NOT MODIFY.
              mov       h+7,x                   'DO NOT MODIFY.
              add       h+10,x                  'DO NOT MODIFY.
              mov       h+13,x                  'DO NOT MODIFY.
              sar       x,#1                    'DO NOT MODIFY.
              add       h+9,x                   'DO NOT MODIFY.
              mov       h+14,x                  'DO NOT MODIFY.
              mov       h+3,x                   'DO NOT MODIFY.
              mov       h+2,x                   'DO NOT MODIFY.
              mov       h+4,x                   'DO NOT MODIFY.
              sar       x,#1                    'DO NOT MODIFY.
              mov       h+18,x                  'DO NOT MODIFY.
              mov       h+0,x                   'DO NOT MODIFY.
              sub       h+5,x                   'DO NOT MODIFY.
              add       h+7,x                   'DO NOT MODIFY.
              mov       h+20,x                  'DO NOT MODIFY.
              mov       h+21,x                  'DO NOT MODIFY.
              mov       h+1,x                   'DO NOT MODIFY.
              mov       h+22,x                  'DO NOT MODIFY.
              sub       h+8,x                   'DO NOT MODIFY.
              add       h+12,x                  'DO NOT MODIFY.
              mov       h+19,x                  'DO NOT MODIFY.
              add       h+10,x                  'DO NOT MODIFY.
              sub       h+11,x                  'DO NOT MODIFY.
              sar       x,#1                    'DO NOT MODIFY.
              mov       h+17,x                  'DO NOT MODIFY.
              sub       h+14,x                  'DO NOT MODIFY.
              mov       h+15,x                  'DO NOT MODIFY.
              sub       h+2,x                   'DO NOT MODIFY.
              add       h+4,x                   'DO NOT MODIFY.
              sar       x,#1                    'DO NOT MODIFY.
              add       h+5,x                   'DO NOT MODIFY.
              add       h+1,x                   'DO NOT MODIFY.
              sub       h+8,x                   'DO NOT MODIFY.
              add       h+10,x                  'DO NOT MODIFY.
              sub       h+13,x                  'DO NOT MODIFY.
              add       h+11,x                  'DO NOT MODIFY.
              sar       x,#1                    'DO NOT MODIFY.
              sub       h+18,x                  'DO NOT MODIFY.
              mov       h+16,x                  'DO NOT MODIFY.
              sub       h+0,x                   'DO NOT MODIFY.
              add       h+7,x                   'DO NOT MODIFY.
              add       h+20,x                  'DO NOT MODIFY.
              add       h+14,x                  'DO NOT MODIFY.
              add       h+21,x                  'DO NOT MODIFY.
              add       h+22,x                  'DO NOT MODIFY.
              add       h+2,x                   'DO NOT MODIFY.
              add       h+4,x                   'DO NOT MODIFY.
              sar       x,#1                    'DO NOT MODIFY.
              add       h+9,x                   'DO NOT MODIFY.
              add       h+6,x                   'DO NOT MODIFY.
              add       h+17,x                  'DO NOT MODIFY.
              add       h+8,x                   'DO NOT MODIFY.
              add       h+3,x                   'DO NOT MODIFY.
              add       h+10,x                  'DO NOT MODIFY.
              add       h+11,x                  'DO NOT MODIFY.
              sar       x,#1                    'DO NOT MODIFY.
              sub       h+18,x                  'DO NOT MODIFY.
              add       h+14,x                  'DO NOT MODIFY.
              sub       h+1,x                   'DO NOT MODIFY.
              add       h+15,x                  'DO NOT MODIFY.
              sub       h+22,x                  'DO NOT MODIFY.
              sub       h+4,x                   'DO NOT MODIFY.
              sar       x,#1                    'DO NOT MODIFY.
              add       h+9,x                   'DO NOT MODIFY.
              add       h+16,x                  'DO NOT MODIFY.
              add       h+17,x                  'DO NOT MODIFY.
              add       h+7,x                   'DO NOT MODIFY.
              sub       h+20,x                  'DO NOT MODIFY.
              sub       h+2,x                   'DO NOT MODIFY.
              add       h+12,x                  'DO NOT MODIFY.
              add       h+19,x                  'DO NOT MODIFY.
              sub       h+10,x                  'DO NOT MODIFY.
              sub       h+13,x                  'DO NOT MODIFY.
              sub       h+11,x                  'DO NOT MODIFY.

'Select the correct channel to process.

              test     sel,#1 wz                'DO NOT MODIFY.
        if_z  jmp      #alt_stages              'DO NOT MODIFY.

'Apply input * coefficients to FIR stages and shift one step.

              mov       y,astage+0              'DO NOT MODIFY.

'Writing the y value here allows overlapped processing with another cog.
'Delete the next line to process the output further in this cog.

              call      #put_ya                 'Write the next output.

              sub       astage+1,h+0            'DO NOT MODIFY.
              mov       astage+0,astage+1       'DO NOT MODIFY.
              mov       astage+1,astage+2       'DO NOT MODIFY.
              sub       astage+3,h+1            'DO NOT MODIFY.
              mov       astage+2,astage+3       'DO NOT MODIFY.
              mov       astage+3,astage+4       'DO NOT MODIFY.
              sub       astage+5,h+2            'DO NOT MODIFY.
              mov       astage+4,astage+5       'DO NOT MODIFY.
              mov       astage+5,astage+6       'DO NOT MODIFY.
              sub       astage+7,h+3            'DO NOT MODIFY.
              mov       astage+6,astage+7       'DO NOT MODIFY.
              mov       astage+7,astage+8       'DO NOT MODIFY.
              sub       astage+9,h+4            'DO NOT MODIFY.
              mov       astage+8,astage+9       'DO NOT MODIFY.
              mov       astage+9,astage+10      'DO NOT MODIFY.
              sub       astage+11,h+5           'DO NOT MODIFY.
              mov       astage+10,astage+11     'DO NOT MODIFY.
              mov       astage+11,astage+12     'DO NOT MODIFY.
              sub       astage+13,h+6           'DO NOT MODIFY.
              mov       astage+12,astage+13     'DO NOT MODIFY.
              mov       astage+13,astage+14     'DO NOT MODIFY.
              sub       astage+15,h+7           'DO NOT MODIFY.
              mov       astage+14,astage+15     'DO NOT MODIFY.
              mov       astage+15,astage+16     'DO NOT MODIFY.
              sub       astage+17,h+8           'DO NOT MODIFY.
              mov       astage+16,astage+17     'DO NOT MODIFY.
              mov       astage+17,astage+18     'DO NOT MODIFY.
              sub       astage+19,h+9           'DO NOT MODIFY.
              mov       astage+18,astage+19     'DO NOT MODIFY.
              mov       astage+19,astage+20     'DO NOT MODIFY.
              sub       astage+21,h+10          'DO NOT MODIFY.
              mov       astage+20,astage+21     'DO NOT MODIFY.
              mov       astage+21,astage+22     'DO NOT MODIFY.
              add       astage+23,h+11          'DO NOT MODIFY.
              mov       astage+22,astage+23     'DO NOT MODIFY.
              mov       astage+23,astage+24     'DO NOT MODIFY.
              add       astage+25,h+12          'DO NOT MODIFY.
              mov       astage+24,astage+25     'DO NOT MODIFY.
              mov       astage+25,astage+26     'DO NOT MODIFY.
              add       astage+27,h+13          'DO NOT MODIFY.
              mov       astage+26,astage+27     'DO NOT MODIFY.
              mov       astage+27,astage+28     'DO NOT MODIFY.
              add       astage+29,h+14          'DO NOT MODIFY.
              mov       astage+28,astage+29     'DO NOT MODIFY.
              mov       astage+29,astage+30     'DO NOT MODIFY.
              add       astage+31,h+15          'DO NOT MODIFY.
              mov       astage+30,astage+31     'DO NOT MODIFY.
              mov       astage+31,astage+32     'DO NOT MODIFY.
              sub       astage+33,h+16          'DO NOT MODIFY.
              mov       astage+32,astage+33     'DO NOT MODIFY.
              mov       astage+33,astage+34     'DO NOT MODIFY.
              sub       astage+35,h+17          'DO NOT MODIFY.
              mov       astage+34,astage+35     'DO NOT MODIFY.
              mov       astage+35,astage+36     'DO NOT MODIFY.
              sub       astage+37,h+18          'DO NOT MODIFY.
              mov       astage+36,astage+37     'DO NOT MODIFY.
              mov       astage+37,astage+38     'DO NOT MODIFY.
              sub       astage+39,h+19          'DO NOT MODIFY.
              mov       astage+38,astage+39     'DO NOT MODIFY.
              mov       astage+39,astage+40     'DO NOT MODIFY.
              sub       astage+41,h+20          'DO NOT MODIFY.
              mov       astage+40,astage+41     'DO NOT MODIFY.
              mov       astage+41,astage+42     'DO NOT MODIFY.
              sub       astage+43,h+21          'DO NOT MODIFY.
              mov       astage+42,astage+43     'DO NOT MODIFY.
              mov       astage+43,astage+44     'DO NOT MODIFY.
              neg       astage+44,h+22          'DO NOT MODIFY.

'Add code here to further process y if the call to put_y was deleted above.          

alt_stages    test      sel,#2 wz               'DO NOT MODIFY.
        if_z  jmp       #main_lp                'DO NOT MODIFY.
        
              sub       bstage+0,h+22           'DO NOT MODIFY.
              mov       y,bstage+0              'DO NOT MODIFY.

'Writing the y value here allows overlapped processing with another cog.
'Delete the next line to process the output further in this cog.

              call      #put_yb                 'Write the next output.

              mov       bstage+0,bstage+1       'DO NOT MODIFY.
              sub       bstage+2,h+21           'DO NOT MODIFY.
              mov       bstage+1,bstage+2       'DO NOT MODIFY.
              mov       bstage+2,bstage+3       'DO NOT MODIFY.
              sub       bstage+4,h+20           'DO NOT MODIFY.
              mov       bstage+3,bstage+4       'DO NOT MODIFY.
              mov       bstage+4,bstage+5       'DO NOT MODIFY.
              sub       bstage+6,h+19           'DO NOT MODIFY.
              mov       bstage+5,bstage+6       'DO NOT MODIFY.
              mov       bstage+6,bstage+7       'DO NOT MODIFY.
              sub       bstage+8,h+18           'DO NOT MODIFY.
              mov       bstage+7,bstage+8       'DO NOT MODIFY.
              mov       bstage+8,bstage+9       'DO NOT MODIFY.
              sub       bstage+10,h+17          'DO NOT MODIFY.
              mov       bstage+9,bstage+10      'DO NOT MODIFY.
              mov       bstage+10,bstage+11     'DO NOT MODIFY.
              sub       bstage+12,h+16          'DO NOT MODIFY.
              mov       bstage+11,bstage+12     'DO NOT MODIFY.
              mov       bstage+12,bstage+13     'DO NOT MODIFY.
              add       bstage+14,h+15          'DO NOT MODIFY.
              mov       bstage+13,bstage+14     'DO NOT MODIFY.
              mov       bstage+14,bstage+15     'DO NOT MODIFY.
              add       bstage+16,h+14          'DO NOT MODIFY.
              mov       bstage+15,bstage+16     'DO NOT MODIFY.
              mov       bstage+16,bstage+17     'DO NOT MODIFY.
              add       bstage+18,h+13          'DO NOT MODIFY.
              mov       bstage+17,bstage+18     'DO NOT MODIFY.
              mov       bstage+18,bstage+19     'DO NOT MODIFY.
              add       bstage+20,h+12          'DO NOT MODIFY.
              mov       bstage+19,bstage+20     'DO NOT MODIFY.
              mov       bstage+20,bstage+21     'DO NOT MODIFY.
              add       bstage+22,h+11          'DO NOT MODIFY.
              mov       bstage+21,bstage+22     'DO NOT MODIFY.
              mov       bstage+22,bstage+23     'DO NOT MODIFY.
              sub       bstage+24,h+10          'DO NOT MODIFY.
              mov       bstage+23,bstage+24     'DO NOT MODIFY.
              mov       bstage+24,bstage+25     'DO NOT MODIFY.
              sub       bstage+26,h+9           'DO NOT MODIFY.
              mov       bstage+25,bstage+26     'DO NOT MODIFY.
              mov       bstage+26,bstage+27     'DO NOT MODIFY.
              sub       bstage+28,h+8           'DO NOT MODIFY.
              mov       bstage+27,bstage+28     'DO NOT MODIFY.
              mov       bstage+28,bstage+29     'DO NOT MODIFY.
              sub       bstage+30,h+7           'DO NOT MODIFY.
              mov       bstage+29,bstage+30     'DO NOT MODIFY.
              mov       bstage+30,bstage+31     'DO NOT MODIFY.
              sub       bstage+32,h+6           'DO NOT MODIFY.
              mov       bstage+31,bstage+32     'DO NOT MODIFY.
              mov       bstage+32,bstage+33     'DO NOT MODIFY.
              sub       bstage+34,h+5           'DO NOT MODIFY.
              mov       bstage+33,bstage+34     'DO NOT MODIFY.
              mov       bstage+34,bstage+35     'DO NOT MODIFY.
              sub       bstage+36,h+4           'DO NOT MODIFY.
              mov       bstage+35,bstage+36     'DO NOT MODIFY.
              mov       bstage+36,bstage+37     'DO NOT MODIFY.
              sub       bstage+38,h+3           'DO NOT MODIFY.
              mov       bstage+37,bstage+38     'DO NOT MODIFY.
              mov       bstage+38,bstage+39     'DO NOT MODIFY.
              sub       bstage+40,h+2           'DO NOT MODIFY.
              mov       bstage+39,bstage+40     'DO NOT MODIFY.
              mov       bstage+40,bstage+41     'DO NOT MODIFY.
              sub       bstage+42,h+1           'DO NOT MODIFY.
              mov       bstage+41,bstage+42     'DO NOT MODIFY.
              mov       bstage+42,bstage+43     'DO NOT MODIFY.
              sub       bstage+44,h+0           'DO NOT MODIFY.
              mov       bstage+43,bstage+44     'DO NOT MODIFY.
              mov       bstage+44,bstage+45     'DO NOT MODIFY.

'Add code here to further process y if the call to put_y was deleted above.          

              jmp       #main_lp                'DO NOT MODIFY.

'This subroutine acquires the next input sample (x) from the hub.
'It can be changed to acquire the sample in another way. The value
'returned in sel should reflect which channel(s) to process:
'bit 0 set for channel a; bit 1 set for channel b.

get_x         rdlong    sel,par wz              'Read select/busy flag. Is it zero?
       if_z   jmp       #get_x                  '  Yes: Keep checking.
       
              rdlong    x,xy_addr               '  No:  Read the input.
get_x_ret     ret

'This subroutine writes the output of the filter (y) to the hub.
'It can be changed to deal with the output in another way.

put_ya        wrlong    y,xy_addr               'Write result to hub.
put_ya_ret    ret

put_yb        wrlong    y,yb_addr
put_yb_ret    ret

'Constants and variables.

astage        long      0[45]                   'DO NOT MODIFY.
bstage        long      0[45]                   'DO NOT MODIFY.
zero          long      0

xy_addr       res       1                       'Hub address of argument.
yb_addr       res       1
sel           res       1
x             res       1                       'DO NOT MODIFY.
y             res       1                       'DO NOT MODIFY.
h             res       23                      'DO NOT MODIFY.
